/*
 * EDG, a library to generate and slice Expression Dependence Graphs.
 * Copyright (c) 2021. David Insa, Sergio Pérez, Josep Silva, Salvador Tamarit.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package edg.config;

import edg.graph.LAST;

public final class Config extends misc.Config
{
	/********************************************************************************************************************************/
	/************************************************************ STATIC ************************************************************/
	/********************************************************************************************************************************/
	private static final Config config = new Config();
	public static final int MAX_PRODUCTION_DEPTH = 5;
	public static final int MAX_STACK_SIZE = 9;
	public static final LAST.Direction SLICE_DIRECTION = LAST.Direction.Backwards;
	public static final boolean GLOBAL_VARIABLES = false;
	public static final boolean PDG = true;
	public static final boolean APDG = false;
	public static final boolean PPDG = false;
	public static Config getConfig()
	{
		return Config.config;
	}

	/********************************************************************************************************************************/
	/************************************************************ OBJECT ************************************************************/
	/********************************************************************************************************************************/
	public final int maxProductionDepth = 5;
	public final int maxStackSize = 9;

	/****************************************************************/
	/************************* Constructor **************************/
	/****************************************************************/
	private Config()
	{
		
	}
}