%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- bench13.erl
%--
%-- AUTHORS:     Susan Horwitz
%-- DATE:        1990         
%-- PUBLISHED:   Interprocedural slicing using dependence graphs
%--              ACM Transactions on Programming Languages and Systems
%--              Volume 12 Issue 1, Jan. 1990 Pages 26-60 
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program proposed by Susan Horwitz was designed to ilustrate the problem of the 
%-- Weiser's slicing algorithm in interprocedural slicing. The program makes a recursive 
%-- call to add up the first 11 naturals.
%-- 
%-- SLICING CRITERION: (38,NewI)
%-- SLICE: Available at: 
%--   http://www.dsic.upv.es/~jsilva/slicing/bencher/slices/b13_s38NewI.erl
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(bench13).
-export([main/0]).

main() -> 
  Sum = 0,
  I = 1,
  {Result,_} = while(Sum,I,11),
  Result.

while(S,I,Top) ->
  if Top /= 0 ->
        NewS = add(S,I),
        NewI = increment(I),      % Slice here
        while(NewS,NewI,Top-1);
      Top == 0 ->
        {S,I}
  end.

add(A,B) -> A+B.
increment(A) -> add(A,1).

