%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- bench16.erl
%--
%-- AUTHORS:     K.B. Gallagher and J.R. Lyle
%-- DATE:        1991         
%-- PUBLISHED:   Using program slicing in software maintenance,
%--              IEEE Transactions on Software Engineering, 
%--              vol. 17, no. 8, 1991.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The word count program, computes the number of lines, words, and characters in an 
%-- input text file.
%--
%-- SLICING CRITERION: (58,C)
%-- SLICE: Available at: 
%--   http://www.dsic.upv.es/~jsilva/slicing/bencher/slices/b16_s58C.erl
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(bench16).
-export([word_count/1]).

-spec word_count(string()) -> any().
word_count(Text) ->
	word_count(Text,0,0,0,false).

word_count([],Chars,Lines,Words,Inword) ->
	{Chars,Lines,Words,Inword};
word_count([C | Text],Chars,Lines,Words,Inword) ->
	NewChars = Chars+1,
	NewLines = 
		case C of
		 	$\n -> 
		 		Lines + 1;
			_ -> 
				Lines
		end,
	{NewWords,NewInword} = 
		case isLetter(C) of
			true -> 
				case Inword of
					false ->
						{Words+1,true};
					true ->
						{Words,Inword}
				end;
			false ->
				{Words,false}
		end,
	word_count(Text,NewChars,NewLines,NewWords,NewInword).

isLetter(C) ->
	io:format("~c ",[C]), 		% Slice here
	if 
		((C >= $A andalso C =< $Z) 
			orelse 
		(C >= $a andalso C =< $z)) -> true;
		true -> false
	end.




	
	