%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- bench2.erl
%--
%-- AUTHORS: 	 Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   Software specially developed to test higher order functions and anonymous
%--              functions.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The benchmark receives two input parameters and executes a call to a function using fun 
%-- expressions. These expressions are stored in variables and are called later.
%--
%-- SLICING CRITERION: (38,C)
%-- SLICE: Available at: 
%--   http://www.dsic.upv.es/~jsilva/slicing/bencher/slices/b2_s38C.erl
%-- 
%-- SLICING CRITERION: (40,D)
%-- SLICE: Available at: 
%--   http://www.dsic.upv.es/~jsilva/slicing/bencher/slices/b2_s40D.erl
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------

-module(bench2).
-export([main/2]).
main(A,B)->
	if 
	    A>B -> 
	   		C=f(A,B);
	    true -> 
	    	C=f(B,A)
	end,
	C,		% Slice here
	D=h(fun g/2,A,B),
	D,		% Slice here
	{C,D}.
f(X,Y) -> 
	Z= X-Y,
	W= X+Y, 
	case Z of
		W -> 
			(fun(B,E) -> 
					N=B*E, 
					B+E 
			end)(X,Y);
		_ -> (fun(N) -> 
				N 
			 end)(W)
	end.
g(X,Y) ->
	(fun(A,B) -> 
		C=A-B, 
		A+B 
	end)(X,Y). 
h(F,A,B) ->  
	C=B*2,
	D= if 
		 B>A -> 
		 	B-3;
		 B=<A -> 
		 	A+5
	   end,
	F(A,B).