%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
%-- bench8.erl
%--
%-- AUTHORS: 	 Anonymous
%-- DATE:        2016           
%-- PUBLISHED:   Software specially developed to test tail recursion and guards.
%--
%-- COPYLEFT:    This Erlang version is distributed in "Bencher: The Program Slicing 
%--              Benchmark Suite for Erlang" (Universitat Politècnica de València). 
%--              It is free of use and publicly available in the URL: 
%--              http://www.dsic.upv.es/~jsilva/slicing/bencher/
%--
%-- DESCRIPTION
%-- The program receives a list of movements in a saving account with the format 
%-- {Movement, Amount, User} and a user Who. It returns two lists, one list
%-- for user's deposits greater than 300 and another one for the withdraws 
%-- greater than 100.
%--
%-- SLICING CRITERION: (29,Deposits)
%-- SLICE: Available at: 
%--   http://www.dsic.upv.es/~jsilva/slicing/bencher/slices/b8_s29Deposits.erl
%-----------------------------------------------------------------------------------------
%-----------------------------------------------------------------------------------------
-module(bench8).
-export([main/2]).

main(Account,Who) -> 
	{Deposits, Withdraws} = recount(Who, Account).	%Slice here
recount(Person, List) -> 
	tailrecount(Person,List,[],[]).
tailrecount(Person,[],LDeposits, LWithdraws) -> 
	{LDeposits,LWithdraws};
tailrecount(Person,[H|T],LDeposits,LWithdraws) -> 
	case H of
		{Mov, Amount, Person} when Mov == withdraw andalso Amount >100 -> 
			tailrecount(Person,T,LDeposits,[H|LWithdraws]);
		{Mov, Amount, Person} when Mov == deposit andalso Amount >300 ->
			tailrecount(Person,T,[H|LDeposits],LWithdraws);
		_ -> 
			tailrecount(Person,T,LDeposits,LWithdraws)
	end.